@mixin circle($size) {
  width: $size;
  height: $size;
  border-radius: 100%;
}

@mixin absPosition($top: auto, $right: auto, $bottom: auto, $left: auto) {
  position: absolute;
  top: $top;
  right: $right;
  bottom: $bottom;
  left: $left;
}

@mixin center-center {
  position: absolute;
  left: 50%;
  top: 50%;
  transform: translate(-50%, -50%);
}

@mixin h-center {
  position: absolute;
  left: 50%;
  transform: translatex(-50%);
}

@mixin v-center {
  position: absolute;
  top: 50%;
  transform: translatey(-50%);
}

@mixin margin-cent {
  margin-left: auto;
  margin-right: auto;
}

@mixin margin-null {
  margin-left: 0;
  margin-right: 0;
}

@mixin upper {
  text-transform: uppercase;
}

@mixin txt-center {
  text-align: center;
}

@mixin txt-justify {
  text-align: justify;
}

@mixin txt-left {
  text-align: left;
}

@mixin txt-right {
  text-align: right;
}

@mixin txt-decoration-none {
  text-decoration: none;
}

@mixin txt-decoration-line {
  text-decoration: underline;
}

@mixin card($depth) {
  @if $depth < 1 {
    box-shadow: none;
  } @else if $depth > 5 {
    @warn "Invalid $depth `#{$depth}` for mixin `card`.";
  } @else {
    box-shadow: bottom-shadow($depth), top-shadow($depth);
  }
}

/// Computes a top-shadow for a card effect.
/// @param {Number} $depth - depth level
/// @return {List}
@function top-shadow($depth) {
  $primary-offset: nth(1.5 3 10 14 19, $depth) * 1px;
  $blur: nth(1.5 3 10 14 19, $depth) * 2px;
  $color: rgba(black, nth(.12 .16 .19 .25 .30, $depth));

  @return 0 $primary-offset $blur $color;
}

/// Computes a bottom-shadow for a card effect.
/// @param {Number} $depth - depth level
/// @return {List}
@function bottom-shadow($depth) {
  $primary-offset: nth(1.5 3 6 10 15, $depth) * 1px;
  $blur: nth(1 3 3 5 6, $depth) * 4px;
  $color: rgba(black, nth(.24 .23 .23 .22 .22, $depth));

  @return 0 $primary-offset $blur $color;
}
